<?php

/*************************************************************************
 * Premium Page  - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\PremiumPage\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int|null service_id
 * @property string title
 * @property string tooltip
 * @property int display_order
 */
class Service extends Entity
{

    public static function getStructure(Structure $structure)
    {
        $structure->table      = 'xc_premium_page_service';
        $structure->shortName  = 'XenConcept\PremiumPage:Service';
        $structure->primaryKey = 'service_id';
        $structure->columns = [
            'service_id' => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'title' => ['type' => self::STR, 'maxLength' => 100,
                'required' => 'please_enter_valid_title',
                'censor' => true
            ],
            'tooltip' => ['type' => self::STR],
            'display_order' => ['type' => self::UINT, 'default' => 0]
        ];
        $structure->getters = [];
        $structure->relations = [

        ];

        return $structure;
    }

}