<?php

/*************************************************************************
 * Premium Page  - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\PremiumPage\Pub\Controller;

use XF\Mvc\ParameterBag;
use XF\Pub\Controller\AbstractController;

class Premium extends AbstractController
{

    protected function preDispatchType($action, ParameterBag $params)
    {
        /** @var \XenConcept\PremiumPage\XF\Entity\User $visitor */
        $visitor = \XF::visitor();
        if (!$visitor->canViewPremiumPage())
        {
            Throw $this->exception($this->noPermission());
        }
    }

    public function actionIndex()
    {
        $serviceRepo   = $this->getServiceRepo();
        $serviceFinder = $serviceRepo->findServicesForList();

        $columnRepo    = $this->getColumnRepo();
        $columnFinder  = $columnRepo->findColumnForList();

        $viewParams = [
            'services' => $serviceFinder->fetch(),
            'columns'  => $columnFinder->fetch()
        ];

        return $this->view('XenConcept\PremiumPage:Premium', 'xc_premium_page', $viewParams);
    }

    public function actionPurchase()
    {
        $userUpgrade = $this->assertRecordExists('XF:UserUpgrade', $this->filter('user_upgrade_id', 'uint'));

        /** @var \XF\Repository\Payment $paymentRepo */
        $paymentRepo = $this->repository('XF:Payment');
        $profiles = $paymentRepo->getPaymentProfileOptionsData();

        $viewParams = [
            'upgrade' => $userUpgrade,
            'profiles' => $profiles
        ];

        return $this->view('XenConcept\PremiumPage:Premium\Purchase', 'xc_premium_page_purchase', $viewParams);
    }

    public static function getActivityDetails(array $activities)
    {
        return \XF::phrase('xc_premium_page_viewing_premium_page');
    }

    /**
     * @return \XenConcept\PremiumPage\Repository\Column
     */
    protected function getColumnRepo()
    {
        return $this->repository('XenConcept\PremiumPage:Column');
    }

    /**
     * @return \XenConcept\PremiumPage\Repository\Service
     */
    protected function getServiceRepo()
    {
        return $this->repository('XenConcept\PremiumPage:Service');
    }


}