<?php

/*************************************************************************
 * Premium Page  - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\PremiumPage;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
    {
        $schemaManager = $this->schemaManager();

        foreach ($this->getTables() AS $tableName => $closure)
        {
            $schemaManager->createTable($tableName, $closure);
        }

        $this->createWidget('xc_premium_page_premium_block', 'xc_premium_page_block', []);
        $this->createWidget('xc_premium_page_visitor_panel', 'visitor_panel', []);
    }

    public function upgrade2000300Step1()
    {
        $this->schemaManager()->alterTable('xc_premium_page_service', function (Alter $table)
        {
            $table->changeColumn('tooltip', 'text');
        });
    }

    public function uninstallStep1()
    {
        $schemaManager = $this->schemaManager();

        foreach (array_keys($this->getTables()) AS $tableName)
        {
            $schemaManager->dropTable($tableName);
        }

        $this->deleteWidget('xc_premium_page_premium_block');
        $this->deleteWidget('xc_premium_page_visitor_panel');
    }
    
    protected function getTables()
    {
        $tables = [];

        $tables['xc_premium_page_column']= function (Create $table)
        {
            $table->addColumn('column_id', 'int')->autoIncrement();
            $table->addColumn('title', 'varchar', 150);
            $table->addColumn('price', 'int')->setDefault(0);
            $table->addColumn('currency', 'varchar', 3)->setDefault('');
            $table->addColumn('header_description', 'varchar', 50);
            $table->addColumn('service_params', 'mediumblob');
            $table->addColumn('footer_description', 'varchar', 50);
            $table->addColumn('title_button_purchase', 'varchar', 150);
            $table->addColumn('user_group_id', 'int')->setDefault(0);
            $table->addColumn('external_link_button_purchase', 'varchar', 150);
        };

        $tables['xc_premium_page_service'] = function (Create $table)
        {
            $table->addColumn('service_id', 'int')->autoIncrement();
            $table->addColumn('title', 'varchar', 150);
            $table->addColumn('tooltip', 'text');
            $table->addColumn('display_order', 'int')->setDefault(0);
        };

        return $tables;
    }

}