<?php

/*************************************************************************
 * Premium Page  - XenConcept (c) 2017
 * All Rights Reserved.
 **************************************************************************
 * This file is subject to the terms and conditions defined in the Licence
 * Agreement available at Try it like it buy it :)
 *************************************************************************/

namespace XenConcept\PremiumPage\Widget;

use XF\Widget\AbstractWidget;

class PremiumBlock extends AbstractWidget
{


    public function render()
    {
        /** @var \XenConcept\PremiumPage\XF\Entity\User $visitor */
        $visitor = \XF::visitor();
        if (!$visitor->canViewPremiumPage())
        {
            return '';
        }

        $latestPremiums = $this->getLatestPremium();

        $viewParams = [
            'latestPremiums' => $latestPremiums
        ];

        return $this->renderer('xc_premium_page_premium_block_widget', $viewParams);
    }

    protected function getLatestPremium()
    {
        $options = \XF::options();

        $maxUsers    = $options->xc_premium_page_new_premium_user_block_max_users;
        $userGroupId = $options->xc_premium_page_new_premium_user_block;

        $finder         = $this->finder('XF:UserUpgrade');
        $userUpgradeIds = $finder->where('extra_group_ids', [$userGroupId])->fetchColumns('user_upgrade_id');

        $newUserUpgradeIds = [];

        foreach ($userUpgradeIds as $userUpgradeId)
        {
            $newUserUpgradeIds[$userUpgradeId['user_upgrade_id']] = $userUpgradeId['user_upgrade_id'];
        }

        $finder = $this->finder('XF:UserUpgradeActive');
        $finder
            ->with(['Upgrade', 'User'])
            ->where('user_upgrade_id', $newUserUpgradeIds)
            ->setDefaultOrder('start_date', 'desc');

        return $finder->fetch($maxUsers);
    }


}